package org.bench4q.agent.scenario.node;

import java.util.ArrayList;
import java.util.Stack;

import org.bench4q.agent.datacollector.DataCollector;
import org.bench4q.agent.scenario.instruction.ControlInstruction;
import org.bench4q.agent.scenario.instruction.Instruction;
import org.bench4q.agent.scenario.instruction.TestInstruction;
import org.bench4q.share.exception.Bench4QRunTimeException;
import org.bench4q.share.models.agent.scriptrecord.BehaviorModel;
import org.bench4q.share.models.agent.statistics.BehaviorBriefModel;

public class ControlBehavior extends PluginImplementBehavior {

	public ControlBehavior(BehaviorModel behaviorModel) {
		if (!behaviorModel.getType()
				.equalsIgnoreCase(Behavior.CONTROL_BEHAVIOR)) {
			throw new Bench4QRunTimeException(
					"Not the right type, here we need CONTROL_BEHAVIOR, but it is"
							+ behaviorModel.getType());
		}
		buildAndGenerateParameterPart(behaviorModel);
	}

	@Override
	public boolean shouldBeCount() {
		return false;
	}

	@Override
	public BehaviorBriefModel getBehaviorBriefResult(
			DataCollector dataStatistics) {
		return null;
	}

	@Override
	public void compile(ArrayList<Instruction> code,
			Stack<TestInstruction> conditions) {
		code.add(new ControlInstruction(this.getUse(), this.getName(), this
				.getParameters()));
	}
}
