package org.bench4q.agent.test.datastatistics;

import static org.junit.Assert.assertEquals;

import java.util.Date;

import org.bench4q.agent.datacollector.impl.BehaviorStatusCodeCollector;
import org.bench4q.agent.scenario.engine.BehaviorResult;
import org.bench4q.share.models.agent.statistics.BehaviorStatusCodeResultModel;
import org.junit.Test;

public class Test_BehaviorStatusResultStatistics {
	@Test
	public void addOneDetailTest() {
		BehaviorStatusCodeCollector statusCodeResultCollector = new BehaviorStatusCodeCollector(
				0, 200, "text/html");
		for (BehaviorResult behaviorResult : Test_ScenarioBriefCollector
				.makeBehaviorList(1, 0)) {
			statusCodeResultCollector.add(behaviorResult);
		}
		BehaviorStatusCodeResultModel resultModel = statusCodeResultCollector
				.getStatistics();
		assertEquals(resultModel.getContentLength(), 20);
		assertEquals(resultModel.getCountThisTime(), 1);
		assertEquals(resultModel.getCount(), 1);
		assertEquals(resultModel.getMaxResponseTime(), 200);
		assertEquals(resultModel.getMinResponseTime(), 200);
		assertEquals(resultModel.getTotalResponseTimeThisTime(), 200);
	}

	@Test
	public void addTwoTest() throws InterruptedException {
		BehaviorStatusCodeCollector statusCodeResultCollector = new BehaviorStatusCodeCollector(
				1, 200, "text/html");
		statusCodeResultCollector.add(Test_ScenarioBriefCollector
				.buildBehaviorResult(300, true, 200, 1, new Date().getTime()));
		Thread.sleep(100);
		statusCodeResultCollector.add(Test_ScenarioBriefCollector
				.buildBehaviorResult(320, true, 200, 1, new Date().getTime()));
		BehaviorStatusCodeResultModel result = statusCodeResultCollector
				.getStatistics();
		assertEquals(result.getContentLength(), 40);
		assertEquals(result.getCountThisTime(), 2);
		assertEquals(result.getCount(), 2);
		assertEquals(result.getMaxResponseTime(), 320);
		assertEquals(result.getMinResponseTime(), 300);
		assertEquals(result.getTotalResponseTimeThisTime(), 620);
	}

	@Test
	public void addThreeAndBriefTwice() {
		BehaviorStatusCodeCollector collector = new BehaviorStatusCodeCollector(
				1, 302, "text/html");
		collector.add(Test_ScenarioBriefCollector.buildBehaviorResult(210, true,
				302, 1, new Date().getTime()));
		collector.add(Test_ScenarioBriefCollector.buildBehaviorResult(230, true,
				302, 1, new Date().getTime()));
		BehaviorStatusCodeResultModel resultModel = collector.getStatistics();
		assertEquals(resultModel.getContentLength(), 40);
		assertEquals(resultModel.getCountThisTime(), 2);
		assertEquals(resultModel.getCount(), 2);
		assertEquals(resultModel.getMaxResponseTime(), 230);
		assertEquals(resultModel.getMinResponseTime(), 210);
		assertEquals(resultModel.getTotalResponseTimeThisTime(), 440);
		collector.add(Test_ScenarioBriefCollector.buildBehaviorResult(190, true,
				302, 1, new Date().getTime()));
		resultModel = collector.getStatistics();
		assertEquals(resultModel.getContentLength(), 60);
		assertEquals(resultModel.getCountThisTime(), 1);
		assertEquals(resultModel.getCount(), 3);
		assertEquals(resultModel.getMaxResponseTime(), 230);
		assertEquals(resultModel.getMinResponseTime(), 190);
		assertEquals(resultModel.getTotalResponseTimeThisTime(), 190);
	}
}
