package org.bench4q.share.models.agent.scriptrecord;

import java.util.List;

import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

import org.bench4q.share.models.agent.ParameterModel;

@XmlRootElement(name = "behaviorModel")
public class BehaviorModel {
	private static final String USER_BEHAVIOR = "USERBEHAVIOR";
	private static final String TIMER_BEHAVIOR = "TIMERBEHAVIOR";
	private static final String TEST_BEHAVIOR = "TESTBEHAVIOR";
	private int id;
	private String use;
	private String name;
	private String type;
	private List<ParameterModel> parameters;

	@XmlElement
	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	@XmlElement
	public String getUse() {
		return use;
	}

	public void setUse(String use) {
		this.use = use;
	}

	@XmlElement
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	@XmlElement
	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	@XmlElementWrapper(name = "parameters")
	@XmlElement(name = "parameter")
	public List<ParameterModel> getParameters() {
		return parameters;
	}

	public void setParameters(List<ParameterModel> parameters) {
		this.parameters = parameters;
	}

	public static BehaviorModel TimerBehaviorBuilder(int id, String name,
			String use, List<ParameterModel> parameters) {
		BehaviorModel behaviorBaseModel = buildBehaviorModelWithoutType(id,
				name, use, parameters);
		behaviorBaseModel.setType(TIMER_BEHAVIOR);
		return behaviorBaseModel;
	}

	private static BehaviorModel buildBehaviorModelWithoutType(int id,
			String name, String use, List<ParameterModel> parameters) {
		BehaviorModel behaviorBaseModel = new BehaviorModel();
		behaviorBaseModel.setId(id);
		behaviorBaseModel.setName(name);
		behaviorBaseModel.setUse(use);
		behaviorBaseModel.setParameters(parameters);
		return behaviorBaseModel;
	}

	public static BehaviorModel UserBehaviorBuilder(int id, String name,
			String use, List<ParameterModel> parameters) {
		BehaviorModel behaviorBaseModel = buildBehaviorModelWithoutType(id,
				name, use, parameters);
		behaviorBaseModel.setType(USER_BEHAVIOR);
		return behaviorBaseModel;
	}

	public static BehaviorModel testBehaviorBuilder(int id, String name,
			String use, List<ParameterModel> params) {
		BehaviorModel result = buildBehaviorModelWithoutType(id, name, use,
				params);
		result.setType(TEST_BEHAVIOR);
		return result;
	}

	public static BehaviorModel ControlBehaviorBuilder(int id, String name,
			String use, List<ParameterModel> parameters) {
		BehaviorModel result = buildBehaviorModelWithoutType(id, name, use,
				parameters);
		result.setType("CONTROLBEHAVIOR");
		return result;
	}

	public static BehaviorModel IfBehaviorBuilder(
			BehaviorModel testBehaviorBuilder,
			List<BehaviorModel> thenBehaviors, List<BehaviorModel> elseBehaviors) {
		// TODO:
		return null;
	}

}
