package org.bench4q.share.models.agent.scriptrecord;

import java.util.LinkedList;
import java.util.List;

import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

@XmlRootElement
public class ScheduleModel {
	private List<PointModel> points;

	@XmlElementWrapper
	@XmlElement
	public List<PointModel> getPoints() {
		return points;
	}

	public void setPoints(List<PointModel> points) {
		this.points = points;
	}

	public ScheduleModel() {
		this.points = new LinkedList<PointModel>();
	}

	public ScheduleModel ratioIntoEffect(double ratio) {
		ScheduleModel result = new ScheduleModel();
		for (PointModel old : this.getPoints()) {
			result.getPoints().add(
					new PointModel(old.getTimeInSecond(), (int) Math.round(old
							.getLoad() * ratio)));
		}
		return result;
	}

	public long getExecuteRange() {
		if (this.points.size() == 0) {
			return 0;
		}
		long endTime = this.points.get(0).getTimeInSecond();
		for (PointModel point : this.getPoints()) {
			endTime = Math.max(point.getTimeInSecond(), endTime);
		}
		return endTime;
	}

	public int getMaxLoad() {
		int result = 0;
		for (PointModel pointModel : this.points) {
			result = Math.max(result, pointModel.getLoad());
		}
		return result;
	}

	@XmlRootElement
	public static class PointModel {
		// Time Unit is second
		private long timeInSecond;
		private int load;

		public PointModel() {
		}

		public PointModel(long timeInSecond, int load) {
			this.setTimeInSecond(timeInSecond);
			this.setLoad(load);
		}

		@XmlElement
		public long getTimeInSecond() {
			return timeInSecond;
		}

		public void setTimeInSecond(long timeInSecond) {
			this.timeInSecond = timeInSecond;
		}

		@XmlElement
		public int getLoad() {
			return load;
		}

		public void setLoad(int load) {
			this.load = load;
		}
	}
}
