package org.bench4q.share.models.agent.statistics;

import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

@XmlRootElement(name = "BehaviorStatusCodeResultModel")
public class BehaviorStatusCodeResultModel extends DataStatisticsModel {
	private int behaviorId;
	private int statusCode;
	private long countThisTime;
	private long count;
	private String contentType;
	private long contentLengthThisTime;
	private long contentLength;
	private long minResponseTime;
	private long maxResponseTime;
	private long totalResponseTimeThisTime;

	@XmlElement
	public int getBehaviorId() {
		return behaviorId;
	}

	public void setBehaviorId(int behaviorId) {
		this.behaviorId = behaviorId;
	}

	@XmlElement
	public int getStatusCode() {
		return statusCode;
	}

	public void setStatusCode(int statusCode) {
		this.statusCode = statusCode;
	}

	@XmlElement
	public long getCount() {
		return count;
	}

	public void setCount(long count) {
		this.count = count;
	}

	@XmlElement
	public long getCountThisTime() {
		return countThisTime;
	}

	public void setCountThisTime(long countThisTime) {
		this.countThisTime = countThisTime;
	}

	@XmlElement
	public String getContentType() {
		return contentType;
	}

	public void setContentType(String contentType) {
		this.contentType = contentType;
	}

	@XmlElement
	public long getContentLengthThisTime() {
		return contentLengthThisTime;
	}

	public void setContentLengthThisTime(long contentLengthThisTime) {
		this.contentLengthThisTime = contentLengthThisTime;
	}

	@XmlElement
	public long getContentLength() {
		return contentLength;
	}

	public void setContentLength(long contentLength) {
		this.contentLength = contentLength;
	}

	@XmlElement
	public long getMinResponseTime() {
		return minResponseTime;
	}

	public void setMinResponseTime(long minResponseTime) {
		this.minResponseTime = minResponseTime;
	}

	@XmlElement
	public long getMaxResponseTime() {
		return maxResponseTime;
	}

	public void setMaxResponseTime(long maxResponseTime) {
		this.maxResponseTime = maxResponseTime;
	}

	@XmlElement
	public long getTotalResponseTimeThisTime() {
		return totalResponseTimeThisTime;
	}

	public void setTotalResponseTimeThisTime(long totalResponseTimeThisTime) {
		this.totalResponseTimeThisTime = totalResponseTimeThisTime;
	}

	/**
	 * It's just the http's success judgement, if we'll turn to other protocal,
	 * we should build a inheritance system
	 * 
	 * @return
	 */
	public boolean isSuccess() {
		return this.getStatusCode() == 200;
	}

	public BehaviorStatusCodeResultModel getCopy() {
		BehaviorStatusCodeResultModel ret = new BehaviorStatusCodeResultModel();
		ret.setStatusCode(getStatusCode());
		ret.setContentLength(getContentLength());
		ret.setContentType(getContentType());
		ret.setCount(getCount());
		ret.setMaxResponseTime(getMaxResponseTime());
		ret.setMinResponseTime(getMinResponseTime());
		ret.setTotalResponseTimeThisTime(getTotalResponseTimeThisTime());
		return ret;
	}

	public synchronized void plus(BehaviorStatusCodeResultModel newOne) {
		this.setContentLength(this.getContentLength()
				+ newOne.getContentLength());
		this.setCount(this.getCount() + newOne.getCount());
		this.setTotalResponseTimeThisTime(this.getTotalResponseTimeThisTime()
				+ newOne.getTotalResponseTimeThisTime());
		if (newOne.getMaxResponseTime() > this.getMaxResponseTime()) {
			this.setMaxResponseTime(newOne.getMaxResponseTime());
		}
		if (newOne.getMinResponseTime() < this.getMinResponseTime()) {
			this.setMinResponseTime(newOne.getMinResponseTime());
		}
	}

	public BehaviorStatusCodeResultModel() {
	}

	public BehaviorStatusCodeResultModel(int behaviorId, int statusCode,
			long countThisTime, long count, String contentType,
			long contentLength, long contentLengthThisTime,
			long minResponseTime, long maxResponseTime,
			long totalResponseTimeThisTime) {
		this.behaviorId = behaviorId;
		this.statusCode = statusCode;
		this.countThisTime = countThisTime;
		this.count = count;
		this.contentType = contentType;
		this.contentLength = contentLength;
		this.contentLengthThisTime = contentLengthThisTime;
		this.minResponseTime = minResponseTime;
		this.maxResponseTime = maxResponseTime;
		this.totalResponseTimeThisTime = totalResponseTimeThisTime;
	}
}
