function loadScripts(){
	$.post("loadScripts", {}, function(data) {
		if (!data.success) {
			information(data.failedMessage);
			return;
		}
		data = data.scripts;
		var script = new Array();
		for ( var i = 0; i < data.length; i++)
			script.push(data[i].name);
		for ( var j = 0; j < script.length; j++) {
			var textNode = document.createTextNode(script[j]);
			var optionNode = document.createElement("option");
			optionNode.setAttribute("value", script[j]);
			optionNode.appendChild(textNode);
			var selectNode = document.getElementsByName("select")[0];
			selectNode.appendChild(optionNode);
		}
	}).error(function(){
		information($.i18n.prop('failed-connect-server'));
	});
}

function loadFilterTypeList(){
	$.post("loadFilterTypeList", {}, function(data) {
		if(!data.success){
			information(data.failedMessage);
			return;
		}else{
			if(!document.getElementsByClassName('clicked')[0]){
				var table = $("<table></table>");
				data = data.filterTypeList;
				var filter = new Array();
				for ( var i = 0; i < data.length; i++)
					filter.push(data[i]);
				for( var j = 0; j < filter.length; j++){
					var checkbox = createCheckbox(filter[j],filter[j]);
					if(j%2==0){
						var tr = $("<tr></tr>");
						table.append(tr);
					}
					tr.append(checkbox);
				}
				$('#filterList').append(table);
			}
		}
	}).error(function(){
		information($.i18n.prop('failed-connect-server'));
	});
}

function getScriptId(scriptName) {
	var scriptId;
	$.ajaxSetup({
		async : false
	});
	$.post("loadScripts", {}, function(data) {
		if (data.success) {
			data = data.scripts;
			for ( var i = 0; i < data.length; i++) {
				if (data[i].name == scriptName) {
					scriptId = data[i].id;
					break;
				}
			}
		}
		else information(data.failedMessage);
	}).error(function(){
		information($.i18n.prop('failed-connect-server'));
	});
	return scriptId;

}
function getPointModelList(allocation,chartPoint){
	var pointModelList = new Array();
	for(var i=0;i< chartPoint.length;i++){
		var realLoad = parseInt(parseInt(chartPoint[i][1])*allocation/100);
		var pointModel = new WebPointModel(parseInt(chartPoint[i][0]),realLoad);
		pointModelList.push(pointModel);
	}
	return pointModelList;
}
function getLimitValue(){
	var limitableFieldArray = $("#targetMode").find("input[class='load-config-input limitable-field']");
	var params = new Array();
	for(var i=0;i< limitableFieldArray.length;i++){
		var field = limitableFieldArray[i];
		var name = field.name;
		var value = field.value;
		var param = new ParameterModel(name,value);
		params.push(param);
	}
	return new LimitModel(params);
}
function start() {
	var scriptList = new Array();
	var ipList = new Array();
	ipList = getIpList();
	var input = $("#userConfig").find("tbody").find("tr").find(".allocation-input");
	var allocationList = new Array();
	var scriptList = new Array();
	var scriptIdList = new Array();
	
	for ( var i = 0; i < input.length; i++)
		allocationList.push(parseInt(input[i].value));
	
	scriptIdList = getScriptIdList();
	
	var isFilterTimer = false;
	var filterTypeMatches = "";
	var filterSelected = $("#filterList").find("input[name='filterList']:checked");
	
	for(var i=0;i<filterSelected.length;i++)
	{
		var id = filterSelected[i].id;
		if(id == "think-time"){
			isFilterTimer = true;
			continue;
		}
		filterTypeMatches += id+"|";
	}
	//delete last |
	if(filterTypeMatches != "")
		filterTypeMatches = filterTypeMatches.substring(0,filterTypeMatches.length-1);
	
	var selectMode = $('input[name="modeSelect"]:checked').val();
	var currentChart;
	var limitModel = null;
	if(selectMode == "custom mode"){
		currentChart = customChart;
	}else{
		currentChart = targetChart;
		//collect limit
		limitModel = getLimitValue();
	}
	var chartPoint = currentChart.options.series[0].data;
	//get schedule model by selected mode
	for ( var k = 0; k < input.length; k++){
		var scheduleModel = new WebScheduleModel(getPointModelList(allocationList[k],chartPoint));
		scriptList.push(new ScriptModel(scriptIdList[k],scheduleModel ,isFilterTimer,filterTypeMatches));
	}

	var name = $("#testConfigurationName").val();
	var testPlan = new TestPlanRequestModel(scriptList, ipList, name, limitModel);
	$.ajax({
		type : "POST",
		url : "runTestPlan",
		contentType : "application/json",
		data : JSON.stringify(testPlan),
		success : function(data) {
			if (data.success)
				window.location.replace("testPlans.jsp");
			else
				information(data.failedMessage);
		},
		error : function(request, status, error) {
			information($.i18n.prop('failed-connect-server'));
		}
	});
}

function loadLimitableFields(){
	$.post("getLimitableFields", {}, function(data) {
		if(!data.success){
			information(data.failedMessage);
			return;
		}else{
			//this is list<String>, limitable fields' name
			data = data.limitableFields.fields;
			var script = new Array();
			for ( var i = 0; i < data.length; i++)
				script.push(data[i]);
			var tbodyNode = document.getElementById("loadConfig2").children[0];
			for ( var j = 0; j < script.length; j++) {
				var textNode = document.createTextNode($.i18n.prop(script[j]));
				var tdNode = document.createElement("td");
				var tdNode2 = document.createElement("td");
				var inputNode = document.createElement("input");
				inputNode.setAttribute("name", script[j]);
				inputNode.setAttribute("class","load-config-input limitable-field");
				inputNode.setAttribute("type","text");
				if(j%2){
					tdNode.appendChild(textNode);
					trNode.appendChild(tdNode);
					tbodyNode.appendChild(trNode);
					tdNode2.appendChild(inputNode);
					trNode2.appendChild(tdNode2);
					tbodyNode.appendChild(trNode2);
				}else{
					var trNode = document.createElement("tr");
					var trNode2 = document.createElement("tr");
					tdNode.appendChild(textNode);
					trNode.appendChild(tdNode);
					tdNode2.appendChild(inputNode);
					trNode2.appendChild(tdNode2);
				}
			}
		}
	}).error(function(){
		information($.i18n.prop('failed-connect-server'));
	});
}
function createNewScript(){
	window.open("script.jsp");
}
function viewScript(node) {
	var scriptId;
	var scriptName;
	var selectNodes = document.getElementsByName("select");
	var index = node.parentNode.parentNode.rowIndex - 1;
	scriptName = selectNodes[index].options[selectNodes[index].selectedIndex].value;
	scriptId = getScriptId(scriptName);
	window.open("editScript.jsp?name=" + scriptName + "&scriptId=" + scriptId);
}
